From 54489f33be2ce5129bc82146d8f26bcd9fff15f1 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Wed, 8 Feb 2012 14:43:04 -0600
Subject: Profile report integration, because why not

---
 grade/report/quick_edit/index.php |   10 ++++++++--
 grade/report/quick_edit/lib.php   |   32 ++++++++++++++++++++++++++++++++
 2 files changed, 40 insertions(+), 2 deletions(-)

diff --git a/grade/report/quick_edit/index.php b/grade/report/quick_edit/index.php
index 1d1719e..ed8da87 100755
--- a/grade/report/quick_edit/index.php
+++ b/grade/report/quick_edit/index.php
@@ -28,10 +28,16 @@ require_once $CFG->dirroot.'/grade/lib.php';
 require_once $CFG->dirroot.'/grade/report/quick_edit/lib.php';
 
 $courseid = required_param('id', PARAM_INT);
-$itemtype = optional_param('item', 'select', PARAM_TEXT);
-$itemid = optional_param('itemid', null, PARAM_INT);
 $groupid  = optional_param('group', null, PARAM_INT);
 
+// Making this work with profile reports
+$userid = optional_param('userid', null, PARAM_INT);
+
+$default_type = $userid ? 'user' : 'select';
+
+$itemid = optional_param('itemid', $userid, PARAM_INT);
+$itemtype = optional_param('item', $default_type, PARAM_TEXT);
+
 $PAGE->set_url(new moodle_url('/grade/report/quick_edit/index.php', array(
     'id' => $courseid,
     'item' => $itemtype,
diff --git a/grade/report/quick_edit/lib.php b/grade/report/quick_edit/lib.php
index 22d0aa0..7738af3 100755
--- a/grade/report/quick_edit/lib.php
+++ b/grade/report/quick_edit/lib.php
@@ -102,3 +102,35 @@ class grade_report_quick_edit extends grade_report {
         return $OUTPUT->box($this->screen->html());
     }
 }
+
+function grade_report_quick_edit_profilereport($course, $user) {
+    global $CFG, $OUTPUT;
+
+    if (!function_exists('grade_report_user_profilereport')) {
+        require_once $CFG->dirroot . '/grade/report/user/lib.php';
+    }
+
+    $context = get_context_instance(CONTEXT_COURSE, $course->id);
+
+    $can_use = (
+        has_capability('gradereport/quick_edit:view', $context) and
+        has_capability('moodle/grade:viewall', $context) and
+        has_capability('moodle/grade:edit', $context)
+    );
+
+    if (!$can_use) {
+        grade_report_user_profilereport($course, $user);
+    } else {
+        $gpr = new grade_plugin_return(array(
+            'type' => 'report',
+            'plugin' => 'quick_edit',
+            'courseid' => $course->id,
+            'userid' => $user->id
+        ));
+
+        $report = new grade_report_quick_edit($course->id, $gpr, $context, 'user', $user->id);
+
+        echo $OUTPUT->heading($report->screen->heading());
+        echo $report->output();
+    }
+}
-- 
1.7.1


